
clc
clear all
addpath(genpath('/lab/raid/models/GBVS/'))
addpath('/lab/borji/borji/projects/Superpixels/codes/simpsal');
addpath(genpath('/lab/borji/borji/projects/Superpixels/SPAMS/SPAMS/'))

addpath(genpath('/lab/raid/models/Judd/TrainAnewModel/benchmark/code/'))


IMGS = '/lab/raid/models/AIM/infosaliency/'; % path to image files


writePathLocal = '/lab/raid/models/OutputSaliency/Scales/2/SNewLocal/';
writePathLG = '/lab/raid/models/OutputSaliency/Scales/2/SNewLG/';
writePathGlobal = '/lab/raid/models/OutputSaliency/Scales/2/SNewGlobal/';
% humanData = load('/lab/raid/models/NoBiasData/Judd/eyeMap.mat');

imagefiles = dir(fullfile(IMGS, '*.jpg'));


PS = 3;
InitScale = [512 512];
numScales = 1;
numImg = 120;
myMap = cell(numImg,3);
comb  = 3
for k=1:numImg%length(imagefiles)
    fprintf('%d \n', k)

    tic
      T=evalc('[salMapLG salMapL salMapG] = myNewSaLModel4NSS([IMGS num2str(k) ''.jpg''],numScales, PS, InitScale, comb);');
%       [salMapLG salMapL salMapG] = myNewSaLModel4NSS([IMGS num2str(k) '.jpg'],numScales, PS, InitScale, comb);
     
    toc
    
%     imwrite(salMapL,[writePathLocal num2str(k) '.jpg'])
%     imwrite(salMapG,[writePathGlobal num2str(k) '.jpg'])
%     imwrite(salMapLG,[writePathLG num2str(k) '.jpg'])


    if min(min(salMapLG)) == max(max(salMapLG))
        fprintf('%s \n', 'Error LG.')
    end
    if min(min(salMapL)) == max(max(salMapL))
        fprintf('%s \n', 'Error L.')
    end
    if min(min(salMapG)) == max(max(salMapG))
        fprintf('%s \n', 'Error G.')
    end
    
    myMap{k,1} = salMapLG;
    myMap{k,2} = salMapL;
    myMap{k,3} = salMapG;
end














% % myModelName = {'LG','L','G'};
% % cd('/lab/raid/models/Judd/TrainAnewModel/benchmark/')
% % myAUCplot = cell(3,1);
% % for j=1:3
% %     myAUCplot{j}=computeROC_mapSet(myMap(:,j),myModelName(j));
% % end
% % myAUCplot = horzcat(myAUCplot{:});
% % % 
% % allGauss = [0.01:0.01:0.05];
% % 
% % cd('/lab/raid/models/OutputSaliency/');
% % % save('BruceNewC4.mat', 'myAUCplot')
% % 
% % figure;
% % plot(allGauss,myAUCplot)
% % legend(myModelName)
% % title(num2str(comb))
% % 

