% calc Saliency for Judd DB
% clear all

% addpath(genpath('/lab/borji/borji/projects/Superpixels/SPAMS/SPAMS'))

clc
clear all
addpath(genpath('/lab/raid/models/GBVS/'))
addpath('/lab/borji/borji/projects/Superpixels/codes/simpsal');
addpath(genpath('/lab/borji/borji/projects/Superpixels/SPAMS/SPAMS/'))

addpath(genpath('/lab/raid/models/Judd/TrainAnewModel/benchmark/code/'))
%addpath('/lab/raid/models/Judd/TrainAnewModel/benchmark/')


IMGS = '/lab/raid/models/Judd/Data/ALLSTIMULI/'; %Change this to the path on your local computer

writePathLocal = '/lab/raid/models/OutputSaliencyJudd/Color/RGB/SNewLocal/';
writePathLG = '/lab/raid/models/OutputSaliencyJudd/Color/RGB/SNewLG/';
writePathGlobal = '/lab/raid/models/OutputSaliencyJudd/Color/RGB/SNewGlobal/';

imagefiles = dir(fullfile(IMGS, '*.jpeg'));
% fprintf('%s \n ', '*');


PS = 1;
InitScale = [512 512];
numScales = 1;
comb = 3; % max
myMap = cell(length(imagefiles),3);
for k=1:length(imagefiles)
    fprintf('%d \n', k)

    %[salMapLG salMapL salMapG] = myNewSaLModel4NSS([IMGS imagefiles(k).name],numScales, PS, InitScale);
      T=evalc('[salMapLG salMapL salMapG] = myNewSaLModel4NSS([IMGS imagefiles(k).name],numScales, PS, InitScale, comb);');
%       T=evalc('[salMapLG salMapL salMapG] = myNewModifiedModel([IMGS num2str(k) ''.jpg''],numScales, PS, InitScale);');
    

    ff = [writePathLocal imagefiles(k).name];
     imwrite(salMapL,ff)

    ff = [writePathGlobal imagefiles(k).name];
     imwrite(salMapG,ff)
    

    ff = [writePathLG imagefiles(k).name];
     imwrite(salMapLG,ff)


    if min(min(salMapLG)) == max(max(salMapLG))
        fprintf('%s \n', 'Error LG.')
    end
    if min(min(salMapL)) == max(max(salMapL))
        fprintf('%s \n', 'Error L.')
    end
    if min(min(salMapG)) == max(max(salMapG))
        fprintf('%s \n', 'Error G.')
    end
    
    myMap{k,1} = salMapLG;
    myMap{k,2} = salMapL;
    myMap{k,3} = salMapG;
end
% % myModelName = {'LG','L','G'};
% % cd('/lab/raid/models/Judd/TrainAnewModel/benchmark/')
% % 
% % itsAllFixFiles = dir('/lab/tmpir/u/dicky/extras/Judd/ALLFIXATIONMAPS/');
% % itsAllStiFiles = dir('/lab/tmpir/u/dicky/extras/Judd/ALLSTIMULI/');
% % itsNumFixFiles = 30%length(itsAllFixFiles);
% % 
% % % % % % % humanData = load('/lab/raid/models/NoBiasData/Judd/eyeMap.mat');
% % % myEye = cell(size(itsAllFixFiles,1)-2,1);
% % 
% % myEye = cell(30,1);
% % for i=3:32%size(itsAllFixFiles,1)
% %     filed=strcat('/lab/tmpir/u/dicky/extras/Judd/ALLFIXATIONMAPS/',itsAllFixFiles(i).name);
% %     fixItem=open(filed);
% %     myEye{i-2} = im2double(fixItem.fixationPts);
% % end
% % 
% % 
% % % idx = cellfun('isempty',myMap);
% % % myMap = myMap(~idx);
% % % myTmpEye = myEye(~idx);
% % 
% % myAUCplot = cell(3,1);
% % for j=1:3
% %     myAUCplot{j}= computeROC_paramSetBorji2(myMapzz(:,j),myEye,myModelName(j));    
% % end
% % myAUCplot = horzcat(myAUCplot{:});
% % % 
% % allGauss = [0.01:0.03:0.15];
% % 
% % cd('/lab/raid/models/OutputSaliencyJudd/');
% % % save('JuddNewC4.mat', 'myAUCplot')



figure;
plot(allGauss,myAUCplot)
legend(myModelName)











% % % % % 
% % % % % % addpath(genpath('/lab/borji/borji/projects/Superpixels/SPAMS/SPAMS'))
% % % % % 
% % % % % addpath(genpath('/lab/raid/models/GBVS/'))
% % % % % addpath('/lab/borji/borji/projects/Superpixels/codes/simpsal');
% % % % % addpath(genpath('/lab/borji/borji/projects/Superpixels/SPAMS/SPAMS/'))
% % % % % 
% % % % % 
% % % % % 
% % % % % IMGS = '/lab/raid/models/Judd/Data/ALLSTIMULI/'; %Change this to the path on your local computer
% % % % % MAPS = '/lab/raid/models/Judd/Data/ALLFIXATIONMAPS/'; %Change this to the path on your local computer
% % % % % 
% % % % % writePathLocal = '/lab/raid/models/OutputSaliencyJudd/SLastLocal/';
% % % % % writePathLG = '/lab/raid/models/OutputSaliencyJudd/SLastLG/';
% % % % % writePathGlobal = '/lab/raid/models/OutputSaliencyJudd/SLastGlobal/';
% % % % % % humanData = load('/lab/raid/models/NoBiasData/Judd/eyeMap.mat');
% % % % % 
% % % % % imagefiles = dir(fullfile(IMGS, '*.jpeg'));
% % % % % 
% % % % % PS = 5;
% % % % % InitScale = [512 512];
% % % % % numScales = 2;
% % % % % for k=1:length(imagefiles)
% % % % %     fprintf('%d \n', k)
% % % % % 
% % % % %     salMap = myNewSaLModel4NSS([IMGS imagefiles(k).name],1,0,numScales, PS, InitScale);
% % % % %     ff = [writePathLocal imagefiles(k).name];
% % % % %     imwrite(salMap,ff)
% % % % %     
% % % % %     salMap = myNewSaLModel4NSS([IMGS imagefiles(k).name],1,1,numScales, PS, InitScale);
% % % % %     ff = [writePathLG imagefiles(k).name];
% % % % %     imwrite(salMap,ff)
% % % % % 
% % % % %     salMap = myNewSaLModel4NSS([IMGS imagefiles(k).name],0,1,numScales, PS, InitScale);
% % % % %     ff = [writePathGlobal imagefiles(k).name];
% % % % %     imwrite(salMap,ff)
% % % % %         
% % % % %     
% % % % % end