% Just for plotting

modelName = {'SAIM' 'SGBVS' 'SHouCVPR' 'SHouNIPS' 'SITTI' 'SJudd' 'SPQFT' 'SSDDR' 'SSUN' 'SSurprise' 'SNew'}

Mypath = '/lab/raid/models/OutputSaliencyJudd/';
fixpath = load('/lab/raid/models/NoBiasData/Judd/eyeMap.mat');

IMGS = '/lab/raid/models/Judd/Data/ALLSTIMULI/'; %Change this to the path on your local computer
MAPS = '/lab/raid/models/Judd/Data/ALLFIXATIONMAPS/'; %Change this to the path on your local computer

figure

imagefiles = dir(fullfile(IMGS, '*.jpeg'));

for k=1:length(imagefiles)

III = imread([IMGS imagefiles]);    
    
[a b k] = fileparts(imagefiles(k).name);
sss = num2str(b);

subplot(4,4,1)
imshow(imresize(III, [size(III,1) size(III,2)]),[])

subplot(4,4,3)
imshow(III,[])

subplot(4,4,2)
III = imread([fixpath 'd' sss '.jpg']);
imshow(imresize(III, [size(finalMap,1) size(finalMap,2)]),[])


for k=1:10
    switch k
        case 1  
            salMap = load([Mypath modelName{k} '/' sss '.mat']);
            salMap = salMap.info;
        case 2  
            salMap = load([Mypath modelName{k} '/' sss '.mat']);
            salMap = salMap.master_map;
        case 3  
            salMap = load([Mypath modelName{k} '/' sss '.mat']);
            salMap = salMap.saliencyMap;            
        case 4
            salMap = imread([Mypath modelName{k} '/' sss '.jpg']);
        case {5, 10} 
            salMap = imread([Mypath modelName{k} '/' sss '.jpg-VCO000000.png']); % Itti
        case 6 % Judd
            salMap = load([Mypath modelName{k} '/' sss '.mat']);
            salMap = salMap.k;
        case 7
            salMap = load([Mypath modelName{k} '/' sss '.mat']);
            salMap = salMap.sM;
        case 8
            salMap = load([Mypath modelName{k} '/' sss '.mat']);
            salMap = salMap.smap;
        case 9
            salMap = load([Mypath modelName{k} '/' sss '.mat']);
            salMap = salMap.simg2;
    end   
    
    subplot(4,4,k+3)
    imshow(imresize(salMap, [size(finalMap,1) size(finalMap,2)]),[])


end
    
end
% pause
% 
% close all
% ff = ['/lab/raid/models/OutputSaliency/SNew/'  sss '.jpg'];
% finalMap = finalMap - min(min(finalMap));
% finalMap = finalMap ./ max(max(finalMap));
% 
% %     imwrite(finalMap,ff)
% 
% figure;
% for k=1:3
%     subplot(3,3,k)
%     imshow(II(:,:,k),[])
% end

