% AWSpath = '/lab/raid/models/OutputSaliency/SAWS/';
% fixpath = '/lab/raid/models/AIM/eyetrackingdata/fixdens/Density Maps produced from raw experimental eye tracking data/';
% 
% addpath(genpath('/lab/raid/models/GBVS/'))
% addpath('/lab/borji/borji/projects/Superpixels/codes/simpsal');
% addpath(genpath('/lab/borji/borji/projects/Superpixels/SPAMS/SPAMS/'))
% % my Saliency
% 
% % Extracting image patches
% % Reconstructing the image with Lasso
% % Use residuals for saliency
% 
% % Lets apply it first to Bruce and Tsotsos dataset which contain balck and
% % white image
% 
% % Phase 1: Generating random patches
% imPath = '/lab/raid/models/AIM/infosaliency/';
% files  = dir([imPath '*.jpg']);
% 
% DS = cell(1,3);
% 
% for m =1:3
%     
%     X = [];
%     for k=1:length(files)
%         k
%         I=double((imread([imPath files(k).name])))/255;
%         I = imresize(I(:,:,m), [512 512]);
%         % extract 8 x 8 patches
%         Y=im2col(I,[8 8],'distinct');
%         Y=Y-repmat(mean(Y),[size(Y,1) 1]);
%         ss = mean(Y.^2) * size(Y,1);
%         Y=Y ./ repmat(sqrt(ss),[size(Y,1) 1]);
% %         Y=Y ./ repmat(sum(Y.^2),[size(Y,1) 1]);
%         X = [X Y];
%     end
%     
%     
%     
%     % I=double(imread('./data/house.png'))/255;
%     
%     % extract 8 x 8 patches
%     % X=im2col(I,[8 8],'sliding');
%     % X=X-repmat(mean(X),[size(X,1) 1]);
%     % X=X ./ repmat(sqrt(sum(X.^2)),[size(X,1) 1]);
%     
%     
%     param.K=400;  % learns a dictionary with 100 elements
%     param.lambda=0.15;
%     param.numThreads=4; % number of threads
%     param.batchsize=400;
%     
%     param.iter=2000;  % let us see what happens after 1000 iterations.
%     
%     
%     %%%%%%%%%% FIRST EXPERIMENT %%%%%%%%%%%
%     tic
%     D = mexTrainDL(X,param);
%     DS{m} = D;
%     t=toc;
%     fprintf('time of computation for Dictionary Learning: %f\n',t);
%     
%     param.approx=0;
%     fprintf('Evaluating cost function...\n');
%     alpha=mexLasso(X,D,param);
%     R=mean(0.5*sum((X-D*alpha).^2)+param.lambda*sum(abs(alpha)));
%     ImD=displayPatches(D);
%     subplot(1,3,1);
%     imagesc(ImD); colormap('gray');
%     fprintf('objective function: %f\n',R);
%     drawnow;
%     
%     
% end % m
% 
% fprintf('*********** SECOND EXPERIMENT ***********\n');
% 
% % IMAGE RECONSTRUCTION
% % loop through images

close all


for k=1:10%length(files)
    k
    dims = [512 512];
    pS = 5;
    ww = dims/8;
    
    figure;
    finalsalMap = zeros(ww);
    
    % Looping through the scale space
    for scaleNo = 1:1
        
        dims = dims/2;
        ww = dims/8;        
        overallsalMap = zeros(ww);
        
        recImg = zeros(dims(1), dims(2),3);
        for m=1:3
            II=double((imread([imPath files(k).name])))/255;
            I = imresize(II(:,:,m), [dims(1) dims(2)]);
            % extract 8 x 8 patches
            X=im2col(I,[8 8],'distinct');
            param.approx=0;
            D = DS{m};
            alpha=mexLasso(X,D,param);
            
            rec = alpha'*D'; % recontructed image
            
            %     Y=Y-repmat(mean(Y),[size(Y,1) 1]);
            %     Y=Y ./ repmat(sqrt(sum(Y.^2)),[size(Y,1) 1]);
            
            A = col2im(rec',[8 8],[dims(1) dims(2)], 'distinct');
            %     A = A + mm;
            
            % Calculating saliency for each image
            % implementing center-surround
            salMap = zeros(1,size(alpha,2));
            kk = dims(1)/ww(1);
            
%             zz = reshape(full(alpha), [size(D,2) ww(1) ww(2)]);
            
            for p1=1:size(alpha,2)
                    sumA = 0;
                    for p2=1:size(alpha,2)
                            if p1==p2;continue;end                        
                            we = 1/abs(p1-p2); % change patch number to 2D coordinates
                            xp1 = fix(p1/ww(1));
                            yp1 = p1- xp1*ww(1);

                            xp2 = fix(p2/ww(1));
                            yp2 = p2- xp2*ww(1);
                            we = 1/abs(pdist2([xp1 yp1], [xp2 yp2])); % change patch number to 2D coordinates                            
                            
%                             sumA = sumA + we * mean(abs([zz(:,p1,p2)]' - [zz(:,p1+jx,p2+jy)]'));                            
                            sumA = sumA + we*pdist2([alpha(:,p1)]' , [alpha(:,p2)]');
                    end
                    salMap(p1) = sumA;
            end
            
            salMap = reshape(salMap, [ww(1) ww(2)]);
            subplot(3,3,m)
            imshow(salMap,[])
            
            % applying
            wj = mypeakiness( salMap );
            overallsalMap = overallsalMap + wj*salMap;
            
            recImg(:,:,m) = A;
        end % end m
        
        
        wj = mypeakiness( overallsalMap );
        finalsalMap = finalsalMap + wj* imresize(overallsalMap,[size(finalsalMap,1) size(finalsalMap,2)] );
        
    end % scaleNo
    
    blurRadius = 0.2;     % e.g. we can change blur radius
    centerbias = 0; cbSize = 1;
    % apply final blura
    if ( blurRadius > 0 )
        ker = mygausskernel( blurRadius * size(finalsalMap,1) , .1 );
        finalsalMap = myconv2(myconv2(finalsalMap,ker),ker');
    end
    
    % apply global center bias
    if ( centerbias )
        h = size(finalsalMap,1);
        w = size(finalsalMap,2);
        finalsalMap = finalsalMap .* (gausswin(h,cbSize) * gausswin(w,cbSize)');
    end
    
    
    
    subplot(3,3,4)
    imshow(imresize(II,[dims(1) dims(2)]))
    
    subplot(3,3,5)
    imshow(recImg,[])
    
    subplot(3,3,6)
    imshow(finalsalMap,[])
    
    subplot(3,3,7)
    sss = files(k).name;
    ii = findstr(sss, '.');
    q = load([AWSpath sss(1:ii-1) '.mat']);
    imshow(q.SaliencyMap,[])
    
    subplot(3,3,8)
    sss = files(k).name;
    III = imread([fixpath 'd' sss ]);
    imshow(III,[])

    
end




