
clc
clear all
addpath(genpath('/lab/raid/models/GBVS/'))
addpath('/lab/borji/borji/projects/Superpixels/codes/simpsal');
addpath(genpath('/lab/borji/borji/projects/Superpixels/SPAMS/SPAMS/'))

IMGS = '/lab/raid/models/Koostra/Data/eyeTrackImages/';
imagefiles = dir(fullfile(IMGS, '*.png'));

writePathLocal = '/lab/raid/models/OutputSaliencyKootstra/Scales/4/SNewLocal/';
writePathLG = '/lab/raid/models/OutputSaliencyKootstra/Scales/4/SNewLG/';
writePathGlobal = '/lab/raid/models/OutputSaliencyKootstra/Scales/4/SNewGlobal/';
% humanData = load('/lab/raid/models/NoBiasData/Judd/eyeMap.mat');

PS = 1;
InitScale = [1024 1024];
numScales = 4;
comb = 3;
myMap = cell(length(imagefiles),3);
for k=1:length(imagefiles)
    fprintf('%d \n', k)
    
    T=evalc('[salMapLG salMapL salMapG] = myNewSaLModel4NSS([IMGS imagefiles(k).name],numScales, PS, InitScale, comb);');
    
    imwrite(salMapL,[writePathLocal imagefiles(k).name])
    imwrite(salMapG,[writePathGlobal imagefiles(k).name])
    imwrite(salMapLG,[writePathLG imagefiles(k).name])
%     
    
    
    if min(min(salMapLG)) == max(max(salMapLG))
        fprintf('%s \n', 'Error LG.')
    end
    if min(min(salMapL)) == max(max(salMapL))
        fprintf('%s \n', 'Error L.')
    end
    if min(min(salMapG)) == max(max(salMapG))
        fprintf('%s \n', 'Error G.')
    end
    
    myMap{k,1} = salMapLG;
    myMap{k,2} = salMapL;
    myMap{k,3} = salMapG;
end


% % myModelName = {'LG','L','G'};
% % cd('/lab/raid/models/Judd/TrainAnewModel/benchmark/')
% % myAUCplot = cell(3,1);
% % for j=1:3
% %     myAUCplot{j}=computeROC_mapSetBorji(myMap(:,j),myModelName(j));
% % end
% % myAUCplot = horzcat(myAUCplot{:});
% % %
% % allGauss = [0.01:0.01:0.05];
% % 
% % cd('/lab/raid/models/OutputSaliencyKootstra/');
% % save('KootC3.mat', 'myAUCplot')
% % 
% % figure;
% % plot(allGauss,myAUCplot)
% % legend(myModelName)
% % title(num2str(comb))












% % % % addpath(genpath('/lab/raid/models/GBVS/'))
% % % % addpath('/lab/borji/borji/projects/Superpixels/codes/simpsal');
% % % % addpath(genpath('/lab/borji/borji/projects/Superpixels/SPAMS/SPAMS/'))
% % % % 
% % % % IMGS = '/lab/raid/models/Koostra/Data/eyeTrackImages/';
% % % % imagefiles = dir(fullfile(IMGS, '*.png'));
% % % % 
% % % % writePathLocal = '/lab/raid/models/OutputSaliencyKootstra/SLastLocal/';
% % % % writePathLG = '/lab/raid/models/OutputSaliencyKootstra/SLastLG/';
% % % % writePathGlobal = '/lab/raid/models/OutputSaliencyKootstra/SLastGlobal/';
% % % % % humanData = load('/lab/raid/models/NoBiasData/Judd/eyeMap.mat');
% % % % 
% % % % PS = 5;
% % % % InitScale = [512 512];
% % % % numScales = 2;
% % % % 
% % % % for k=1:length(imagefiles)
% % % %     fprintf('%d \n', k)
% % % % 
% % % %     salMap = myNewSaLModel4NSS([IMGS imagefiles(k).name],1,0,numScales, PS, InitScale);
% % % %     ff = [writePathLocal imagefiles(k).name];
% % % %     imwrite(salMap,ff)
% % % %     
% % % %     salMap = myNewSaLModel4NSS([IMGS imagefiles(k).name],1,1,numScales, PS, InitScale);
% % % %     ff = [writePathLG imagefiles(k).name];
% % % %     imwrite(salMap,ff)
% % % % 
% % % %     salMap = myNewSaLModel4NSS([IMGS imagefiles(k).name],0,1,numScales, PS, InitScale);
% % % %     ff = [writePathGlobal imagefiles(k).name];
% % % %     imwrite(salMap,ff)
% % % %     
% % % %     %     figure; imshow(salMap, [])
% % % % %     pause
% % % % end
% % % % 
