
clc
clear all
addpath(genpath('/lab/raid/models/GBVS/'))
addpath('/lab/borji/borji/projects/Superpixels/codes/simpsal');
addpath(genpath('/lab/borji/borji/projects/Superpixels/SPAMS/SPAMS/'))

addpath(genpath('/lab/raid/models/Judd/TrainAnewModel/benchmark/code/'))
%addpath('/lab/raid/models/Judd/TrainAnewModel/benchmark/')

IMGS = '/lab/tmpir/u/dicky/nusef/NUSEF_database/stimuli/';
imagefiles = dir(fullfile(IMGS, '*.jpg')); % load the image list

sss = '/lab/tmpir/u/dicky/nusef/OutputSaliency/';  % output directory

writePathLocal = [sss 'Color/RGB/SNewLocal/'];
writePathLG = [sss 'Color/RGB/SNewLG/'];
writePathGlobal = [sss 'Color/RGB/SNewGlobal/'];


PS = 1;
InitScale = [512 512];
numScales = 1;
comb = 3;
myMap = cell(length(imagefiles),3);
for k=1:length(imagefiles)
    fprintf('%d \n', k)
    
    % calls the main code
    T=evalc('[salMapLG salMapL salMapG] = myNewSaLModel4NSS([IMGS imagefiles(k).name],numScales, PS, InitScale, comb);');

    [a b c ] = fileparts(imagefiles(k).name);
    ff = [writePathLocal b]; save([ff '.mat'],'salMapL')
    
    ff = [writePathLG b]; save([ff '.mat'],'salMapLG')
    
    ff = [writePathGlobal b]; save([ff '.mat'],'salMapG')
    
    
    if min(min(salMapLG)) == max(max(salMapLG))
        fprintf('%s \n', 'Error LG.')
    end
    if min(min(salMapL)) == max(max(salMapL))
        fprintf('%s \n', 'Error L.')
    end
    if min(min(salMapG)) == max(max(salMapG))
        fprintf('%s \n', 'Error G.')
    end
    
    myMap{k,1} = salMapLG;
    myMap{k,2} = salMapL;
    myMap{k,3} = salMapG;
end



% % % myModelName = {'LG','L','G'};
% % % cd('/lab/raid/models/Judd/TrainAnewModel/benchmark/')
% % % 
% % % addpath('/lab/tmpir/u/dicky/nusef/NUSEF_database/code/')
% % % itsAllStiFiles = dir('/lab/tmpir/u/dicky/nusef/NUSEF_database/stimuli/*.jpg');
% % % itsNumFixFiles = length(itsAllStiFiles);
% % % myEye = cell(size(itsAllStiFiles,1),1);
% % % % myEye = cell(50,1);
% % % 
% % % for i=1:size(itsAllStiFiles,1)
% % %     fixItem = get_NUSEF_fix_data(itsAllStiFiles(i).name);
% % %     myEye{i}=im2double(fixItem.map);
% % % end
% % % 
% % % myAUCplot = cell(3,1);
% % % for j=1:3
% % %     myAUCplot{j}=computeROC_paramSetBorji2(myMap(:,j),myEye,myModelName(j));
% % % end
% % % myAUCplot = horzcat(myAUCplot{:});
% % % %
% % % allGauss = [0.01:0.01:0.05];
% % % 
% % % cd('/lab/tmpir/u/dicky/nusef/OutputSaliency/');
% % % save('NusefC3.mat', 'myAUCplot')
% % % 
% % % figure;
% % % plot(allGauss,myAUCplot)
% % % legend(myModelName)
% % % title(num2str(comb))










% % % % addpath(genpath('/lab/raid/models/GBVS/'))
% % % % addpath('/lab/borji/borji/projects/Superpixels/codes/simpsal');
% % % % addpath(genpath('/lab/borji/borji/projects/Superpixels/SPAMS/SPAMS/'))
% % % %
% % % % IMGS = '/lab/tmpir/u/dicky/nusef/NUSEF_database/stimuli/';
% % % % imagefiles = dir(fullfile(IMGS, '*.jpg'));
% % % %
% % % %
% % % % sss = '/lab/tmpir/u/dicky/nusef/OutputSaliency/';
% % % %
% % % % writePathLocal = [sss 'SLastLocal/'];
% % % % writePathLG = [sss 'SLastLG/'];
% % % % writePathGlobal = [sss '/SLastGlobal/'];
% % % % % humanData = load('/lab/raid/models/NoBiasData/Judd/eyeMap.mat');
% % % %
% % % % PS = 2;
% % % % numScales = 2;
% % % % InitScale = [512 512];
% % % %
% % % % for k=1:length(imagefiles)
% % % %     fprintf('%d \n', k)
% % % %
% % % %
% % % %      SM = myNewSaLModel4NSS([IMGS imagefiles(k).name],1,0,numScales, PS,InitScale);
% % % %      [a b c ] = fileparts(imagefiles(k).name);
% % % %      ff = [writePathLocal b];
% % % %      save([ff '.mat'],'SM')
% % % %
% % % %     SM = myNewSaLModel4NSS([IMGS imagefiles(k).name],1,1,numScales, PS,InitScale);
% % % %     [a b c ] = fileparts(imagefiles(k).name);
% % % %     ff = [writePathLG b];
% % % %     save([ff '.mat'],'SM')
% % % %
% % % %      SM = myNewSaLModel4NSS([IMGS imagefiles(k).name],0,1,numScales, PS,InitScale);
% % % %      [a b c ] = fileparts(imagefiles(k).name);
% % % %      ff = [writePathGlobal b];
% % % %      save([ff '.mat'],'SM')
% % % %
% % % %
% % % %     %     figure; imshow(salMap, [])
% % % % %     pause
% % % % end
