% Just for plotting

%%% Gaussian blob
dims = [50 50]; sigma = 10; % gaussian standard deviation in pixels <<<<<<<<<<<<<
P = [round(dims(1)/2) round(dims(2)/2)];
[Xm Ym] = meshgrid(-P(2):P(2), -P(1):P(1)); s = sigma ;
gauss = exp(-((( Xm.^2)+( Ym.^2)) ./ (2* s^2)));


modelName = {'SAIM' 'SGBVS' 'SHouCVPR' 'SHouNIPS' 'SITTI' 'SJudd' 'SPQFT' 'SSDDR' 'SSUN' 'SSurprise' 'SNew'}

Mypath = '/lab/raid/models/OutputSaliencyJudd/';
% fixpath = load('/lab/raid/models/NoBiasData/Judd/eyeMap.mat');
close all

IMGS = '/lab/raid/models/Judd/Data/ALLSTIMULI/'; %Change this to the path on your local computer
MAPS = '/lab/raid/models/Judd/Data/ALLFIXATIONMAPS/'; %Change this to the path on your local computer

figure

% imagefiles = dir(fullfile(IMGS, '*.jpeg'));

for k=1:length(imagefiles)

III = imread([IMGS imagefiles(k).name]);    
    
subplot(4,4,1)
imshow(III,[])
    title(imagefiles(k).name)
    
[a b dd] = fileparts(imagefiles(k).name);


filed=strcat('/lab/tmpir/u/dicky/extras/Judd/ALLFIXATIONMAPS/',b,'.mat');
fixItem=open(filed);

%     himg=im2double(fixItem.saliencyMapBlur);
subplot(4,4,2)
imshow(fixItem.saliencyMapBlur, [])

sss= b;
% imshow(imresize(humanMap, [size(III,1) size(III,2)]),[])

for k=1:11
    switch k
        case 1  
            salMap = (load([Mypath modelName{k} '/' sss '..mat']));
            salMap = salMap.info;           
        case 2  
            salMap = load([Mypath modelName{k} '/' sss '.mat']);
            salMap = salMap.master_map;
        case 3  
            if exist([Mypath modelName{k} '/' sss '.jpeg.mat'], 'file')
                salMap = load([Mypath modelName{k} '/' sss '.jpeg.mat']);
                salMap = salMap.saliencyMap;            
            end 
        case 4
            if exist([Mypath modelName{k} '/' sss '..mat'], 'file')
                salMap = load([Mypath modelName{k} '/' sss '..mat']);
                salMap = salMap.mySMap;            
                
            end
        case {5, 10} 
            salMap = imread([Mypath modelName{k} '/' sss '.jpeg-VCO000000.png']); % Itti
        case 6 % Judd
            salMap = load([Mypath modelName{k} '/' sss '.mat']);
            salMap = salMap.k;
        case 7
            salMap = load([Mypath modelName{k} '/' sss '.mat']);
            salMap = salMap.sM;
        case 8
            salMap = load([Mypath modelName{k} '/' sss '.mat']);
            salMap = salMap.smap;
        case 9
            salMap = load([Mypath modelName{k} '/' sss '.mat']);
            salMap = salMap.simg2;
            
        case 11
             salMap = imread([Mypath modelName{k} '/' sss '.jpeg']);            
    end   
    
    subplot(4,4,k+2)
    imshow(imresize(salMap, [size(III,1) size(III,2)]),[])


end
    pause
end
% pause
% 
% close all
% ff = ['/lab/raid/models/OutputSaliency/SNew/'  sss '.jpg'];
% finalMap = finalMap - min(min(finalMap));
% finalMap = finalMap ./ max(max(finalMap));
% 
% %     imwrite(finalMap,ff)
% 
% figure;
% for k=1:3
%     subplot(3,3,k)
%     imshow(II(:,:,k),[])
% end

